long_tel=116;
larg_tel=49.5;
ep_tel=12.5;
larg_elastique=7;
ep_elastique=3;
ep_plaque=1.5;

r_ecrou_m3=3.3;
r_trou_m3=2;

module support_tel(){
difference(){
	hull(){
		cube([larg_tel+20,long_tel+5+5,ep_tel+2]);
	
		translate([larg_tel+20,5,0]){cylinder(h = ep_tel+2, r = 5, $fn=50);}
		translate([larg_tel+20,long_tel+5,0]){cylinder(h = ep_tel+2, r = 5, $fn=50);}
	}

	//extrusion pour passage sous plaque
	translate([-5,-5,ep_tel+2-ep_plaque]){cube([25,long_tel+30,2]);}

	//trous de vissage
	translate([10,long_tel+10-15,-5]){cylinder(h = ep_tel+10, r = r_trou_m3, $fn=50);}
	translate([10,long_tel+10-15,-5]){cylinder(h = 12, r = r_ecrou_m3, $fn=6);}

	translate([10,15,-5]){cylinder(h = ep_tel+10, r = r_trou_m3, $fn=50);}
	translate([10,15,-5]){cylinder(h = 12, r = r_ecrou_m3, $fn=6);}

	//emplacement du téléphone
	translate([22,5,2]){cube([larg_tel,long_tel,ep_tel+5]);}

	//allègement du trou téléphone
	hull(){
		translate([31,15,-5]){cylinder(h = 10, r = 5, $fn=50);}
		translate([31+32,15,-5]){cylinder(h = 10, r = 5, $fn=50);}

		translate([31,long_tel-5,-5]){cylinder(h = 10, r = 5, $fn=50);}
		translate([31+32,long_tel-5,-5]){cylinder(h = 10, r = 5, $fn=50);}
	}

	//extrusions pour élastique
	translate([-5,47,ep_tel-1]){cube([100,larg_elastique,5]);}
	translate([-5,47,ep_tel-3]){cube([30,larg_elastique,5]);}
	translate([-5,47,-5]){cube([20,larg_elastique,30]);}

	//extrusions pour boutons
	translate([20,68,2]){cube([3,28,20]);}
	translate([60,34,4]){cube([20,11,5]);}
}

}

module plaque_cuisse(){
difference(){
	cube([largeur,longueur,hauteur]);

	//cylindre pour passage cuisse
	translate([largeur/2,-5,r_cuisse+10]){rotate([-90,0,0])cylinder(h = longueur+10, r = r_cuisse, $fn=200);}
	
	//passages pour sangle
	translate([-5,15,-5]){cube([largeur+10,l_sangle,5+ep_sangle]);}
	translate([-5,15,0]){cube([trou_sangle+5,l_sangle,hauteur+10]);}
	translate([largeur-trou_sangle,15,0]){cube([trou_sangle+5,l_sangle,hauteur+10]);}


	translate([-5,longueur-15-l_sangle,-5]){cube([largeur+10,l_sangle,5+ep_sangle]);}
	translate([-5,longueur-15-l_sangle,0]){cube([trou_sangle+5,l_sangle,hauteur+10]);}
	translate([largeur-trou_sangle,longueur-15-l_sangle,0]){cube([trou_sangle+5,l_sangle,hauteur+10]);}

	//trous de vissage
	translate([l_trou,8,-5]){cylinder(h = hauteur+10, r = r_trou_m3, $fn=50);}
	translate([l_trou,8,hauteur-5]){rotate([0,0,30])cylinder(h = 7, r = r_ecrou_m3, $fn=6);}

	translate([largeur-l_trou,8,-5]){cylinder(h = hauteur+10, r = r_trou_m3, $fn=50);}
	translate([largeur-l_trou,8,hauteur-5]){rotate([0,0,30])cylinder(h = 7, r = r_ecrou_m3, $fn=6);}

	translate([largeur-l_trou,longueur/2,-5]){cylinder(h = hauteur+10, r = r_trou_m3, $fn=50);}
	translate([largeur-l_trou,longueur/2,hauteur-5]){rotate([0,0,30])cylinder(h = 7, r = r_ecrou_m3, $fn=6);}
	
	translate([l_trou,longueur/2,-5]){cylinder(h = hauteur+10, r = r_trou_m3, $fn=50);}
	translate([l_trou,longueur/2,hauteur-5]){rotate([0,0,30])cylinder(h = 7, r = r_ecrou_m3, $fn=6);}

	translate([largeur-l_trou,longueur-8,-5]){cylinder(h = hauteur+10, r = r_trou_m3, $fn=50);}
	translate([largeur-l_trou,longueur-8,hauteur-5]){rotate([0,0,30])cylinder(h = 7, r = r_ecrou_m3, $fn=6);}
	
	translate([l_trou,longueur-8,-5]){cylinder(h = hauteur+10, r = r_trou_m3, $fn=50);}
	translate([l_trou,longueur-8,hauteur-5]){rotate([0,0,30])cylinder(h = 7, r = r_ecrou_m3, $fn=6);}

	
}
}

support_tel();